<template>
  <PageWrapper dense>
   
        <BasicTable @register="registerTable">
          <template #toolbar>
            <a-button
              @click="
                downloadExcel(
                  factoryInfoExport,
                  '生产厂家基础信息;数据',
                  getForm().getFieldsValue()
                )
              "
              v-auth="'factory:factoryInfo:export'"
              >导出</a-button
            >
            <a-button
              type="primary"
              danger
              @click="multipleRemove(factoryInfoRemove)"
              :disabled="!selected"
              v-auth="'factory:factoryInfo:remove'"
              >删除</a-button
            >
            <a-button type="primary" @click="handleAdd" v-auth="'factory:factoryInfo:add'"
              >新增</a-button
            >
          </template>
          <template #bodyCell="{ column, record }">
            <template v-if="column.key === 'state'">
              <div>{{ record.state === 1 ? "正常" : "问题" }}</div>
            </template>
            <template v-if="column.key === 'action'">
              <TableAction
                stopButtonPropagation
                :actions="[
                  {
                    label: '查看',

                    type: 'primary',
                    ghost: true,
                    auth: 'behavior:behaviorMessage:query',
                    onClick: handCheck.bind(null, record),
                  },
                  {
                    label: '修改',

                    type: 'primary',
                    ghost: true,
                    auth: 'factory:factoryInfo:edit',
                    onClick: handleEdit.bind(null, record),
                  },
                  {
                    label: '删除',

                    type: 'primary',
                    danger: true,
                    ghost: true,
                    auth: 'factory:factoryInfo:remove',
                    popConfirm: {
                      placement: 'left',
                      title: '是否删除生产厂家基础信息;[' + record.id + ']?',
                      confirm: handleDelete.bind(null, record),
                    },
                  },
                ]"
              />
            </template>
          </template> </BasicTable
      >

    <FactoryInfoModal @register="registerModal" @reload="reload" />
  </PageWrapper>
</template>

<script setup lang="ts">
import { PageWrapper } from "@/components/Page";
import { BasicTable, useTable, TableAction } from "@/components/Table";
import {
  factoryInfoList,
  factoryInfoExport,
  factoryInfoRemove,
} from "@/api/basicInfo/outputFactory";
import { downloadExcel } from "@/utils/file/download";
import { useModal } from "@/components/Modal";
import FactoryInfoModal from "./FactoryInfoModal.vue";
import { formSchemas, columns } from "./factoryInfo.data";
import { IconEnum } from "@/enums/appEnum";
import { columnList } from "../../../api/tool/gen/index";
import DeptTree from "@/components/commonDeptTree/DeptTree.vue";
import { ref, toValue } from "vue";
import { Row, Col } from "ant-design-vue";
defineOptions({ name: "FactoryInfo" });
const selectDeptId = ref<string[]>([]);
const searchValue = ref<string>("");
const [registerTable, { reload, multipleRemove, selected, getForm }] = useTable({
  rowSelection: {
    type: "checkbox",
  },
  title: "生产厂家基础信息;列表",
  api: factoryInfoList,
  showIndexColumn: true,
  rowKey: "id",
  useSearchForm: true,
  formConfig: {
    schemas: formSchemas,
    baseColProps: {
      xs: 24,
      sm: 24,
      md: 24,
      lg: 6,
    },
    resetFunc: async () => {
      selectDeptId.value = [];
      searchValue.value = "";
      await reload();
    },
  },
  // 需要添加上部门参数
  beforeFetch(params: Recordable) {
    if (toValue(selectDeptId).length === 1) {
      params.deptId = toValue(selectDeptId)[0];
    }
    return params;
  },
  columns: columns,
  actionColumn: {
    width: 200,
    title: "操作",
    key: "action",
    fixed: "right",
  },
});

const [registerModal, { openModal }] = useModal();

function handleEdit(record: Recordable) {
  openModal(true, { record, update: 1 });
}

function handleAdd() {
  openModal(true, { update: 2 });
}
function handCheck(record: Recordable) {
  openModal(true, { record, update: 3 });
}
async function handleDelete(record: Recordable) {
  await factoryInfoRemove([record.id]);
  await reload();
}
</script>

<style scoped></style>
